"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var components = [];

/*
  QuickUnion is faster than QuickFind,
  but also too slow.
  QuickUnion's defect is that it's trees
  could get too tall.
  This would mean that the find operation
  would be too expensive.
  You could end up with 1 long skinny tree,
  with one object pointing to the next.
  Doing a find operation for a node on the bottom,
  would involve going all the way to the tree
  involving N array access just for find (too slow)
*/

var QuickUnion = function () {
  function QuickUnion(args) {
    _classCallCheck(this, QuickUnion);

    for (var i = 0; i < args.length; i++) {
      components.push(args[i]);
    }
  }

  _createClass(QuickUnion, [{
    key: "root",
    value: function root(i) {
      while (i !== components[i]) {
        i = components[i];
      }
      return i;
    }

    /* */

  }, {
    key: "connected",
    value: function connected(p, q) {
      root(p) === root(q);
    }

    /* Union is fast in QuickUnion
       since you just the roots of components.
       So you just end up changing 1 value in an array,
       to merge 2 components.
    */

  }, {
    key: "union",
    value: function union(p, q) {
      var i = root(p);
      var j = root(q);
      components[i] = j;
    }
  }]);

  return QuickUnion;
}();